<template>
    <label :for="elId" class="app-checkbox" :class="{checked: isChecked}">
        <input type="checkbox" :checked="isChecked" :id="elId" @change="toggle"/>
    </label>
</template>

<script>
    export default {
        name: "AppCheckbox",
        props: {
            elId: {
                type: String,
                required: true
            },
            checked: {
                type: Boolean,
                default: () => true
            }
        },
        data: function () {
            return {
                isChecked: this.checked
            }
        },
        methods: {
            toggle: function () {
                this.isChecked = !this.isChecked;
                this.$emit('change', {checked: this.isChecked})
            }
        },
        watch: {
            checked: function(val) {
                this.isChecked = val;
            }
        }
    }
</script>

<style scoped lang="scss">
    .app-checkbox {
        position: relative;
        height: 21px;
        display: flex;
        align-items: center;
        
        &:hover {
            cursor: pointer;
        }

        input[type=checkbox] {
            display: none;
        }

        &:before {
            display: block;
            content: '';
            width: 42px;
            height: 17px;
            border-radius: 8px;
            background-color: #0263ff;
        }

        &:after {
            position: absolute;
            top: 0;
            left: -2px;
            display: block;
            content: '';
            width: 21px;
            height: 21px;
            box-shadow: 0 1px 7px rgba(186, 195, 205, 0.73), 0 1px 30px rgba(186, 195, 205, 0.72);
            border-radius: 7px;
            background-color: #ffffff;
            transition: left .3s ease-in-out;
        }

        &.checked {
            &:after {
                left: 23px;
            }
        }
    }
</style>
